diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/qos-txop.cc ns-3.38/src/wifi/model/qos-txop.cc
--- ns-3.37/src/wifi/model/qos-txop.cc	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/qos-txop.cc	2023-03-16 20:54:23.860869400 -0700
@@ -90,6 +90,12 @@
                           PointerValue(),
                           MakePointerAccessor(&QosTxop::m_baManager),
                           MakePointerChecker<BlockAckManager>())
+            .AddAttribute("NMaxInflights",
+                          "The maximum number of links (in the range 1-15) on which an MPDU can be "
+                          "simultaneously in-flight.",
+                          UintegerValue(1),
+                          MakeUintegerAccessor(&QosTxop::m_nMaxInflights),
+                          MakeUintegerChecker<uint8_t>(1, 15))
             .AddTraceSource("TxopTrace",
                             "Trace source for TXOP start and duration times",
                             MakeTraceSourceAccessor(&QosTxop::m_txopTrace),
@@ -257,14 +263,6 @@
     return m_baManager;
 }
 
-bool
-QosTxop::GetBaAgreementEstablished(Mac48Address address, uint8_t tid) const
-{
-    return m_baManager->ExistsAgreementInState(address,
-                                               tid,
-                                               OriginatorBlockAckAgreement::ESTABLISHED);
-}
-
 uint16_t
 QosTxop::GetBaBufferSize(Mac48Address address, uint8_t tid) const
 {
@@ -277,32 +275,29 @@
     return m_baManager->GetOriginatorStartingSequence(address, tid);
 }
 
-Ptr<const WifiMpdu>
+Ptr<WifiMpdu>
 QosTxop::PrepareBlockAckRequest(Mac48Address recipient, uint8_t tid) const
 {
     NS_LOG_FUNCTION(this << recipient << +tid);
     NS_ASSERT(QosUtilsMapTidToAc(tid) == m_ac);
 
-    CtrlBAckRequestHeader reqHdr = m_baManager->GetBlockAckReqHeader(recipient, tid);
+    auto recipientMld = m_mac->GetMldAddress(recipient);
+
+    CtrlBAckRequestHeader reqHdr =
+        m_baManager->GetBlockAckReqHeader(recipientMld.value_or(recipient), tid);
     Ptr<Packet> bar = Create<Packet>();
     bar->AddHeader(reqHdr);
 
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_CTL_BACKREQ);
     hdr.SetAddr1(recipient);
-    hdr.SetAddr2(m_mac->GetAddress());
+    hdr.SetAddr2(m_mac->GetLocalAddress(recipient));
     hdr.SetDsNotTo();
     hdr.SetDsNotFrom();
     hdr.SetNoRetry();
     hdr.SetNoMoreFragments();
 
-    return Create<const WifiMpdu>(bar, hdr);
-}
-
-void
-QosTxop::ScheduleBar(Ptr<const WifiMpdu> bar, bool skipIfNoDataQueued)
-{
-    m_baManager->ScheduleBar(bar, skipIfNoDataQueued);
+    return Create<WifiMpdu>(bar, hdr);
 }
 
 bool
@@ -314,16 +309,12 @@
 bool
 QosTxop::HasFramesToTransmit(uint8_t linkId)
 {
-    // check if the BA manager has anything to send, so that expired
-    // frames (if any) are removed and a BlockAckRequest is scheduled to advance
-    // the starting sequence number of the transmit (and receiver) window
-    bool baManagerHasPackets{m_baManager->GetBar(false)};
     // remove MSDUs with expired lifetime starting from the head of the queue
     m_queue->WipeAllExpiredMpdus();
     bool queueIsNotEmpty = (bool)(m_queue->PeekFirstAvailable(linkId, m_qosBlockedDestinations));
 
-    NS_LOG_FUNCTION(this << baManagerHasPackets << queueIsNotEmpty);
-    return baManagerHasPackets || queueIsNotEmpty;
+    NS_LOG_FUNCTION(this << queueIsNotEmpty);
+    return queueIsNotEmpty;
 }
 
 uint16_t
@@ -351,7 +342,7 @@
     Mac48Address recipient = mpdu->GetHeader().GetAddr1();
     uint8_t tid = mpdu->GetHeader().GetQosTid();
 
-    if (!GetBaAgreementEstablished(recipient, tid))
+    if (!m_mac->GetBaAgreementEstablishedAsOriginator(recipient, tid))
     {
         return false;
     }
@@ -365,89 +356,118 @@
 }
 
 Ptr<WifiMpdu>
-QosTxop::PeekNextMpdu(uint8_t linkId, uint8_t tid, Mac48Address recipient, Ptr<WifiMpdu> item)
+QosTxop::PeekNextMpdu(uint8_t linkId, uint8_t tid, Mac48Address recipient, Ptr<const WifiMpdu> mpdu)
 {
-    NS_LOG_FUNCTION(this << +linkId << +tid << recipient << item);
+    NS_LOG_FUNCTION(this << +linkId << +tid << recipient << mpdu);
 
     // lambda to peek the next frame
-    auto peek = [this, &linkId, &tid, &recipient, &item]() -> Ptr<WifiMpdu> {
+    auto peek = [this, &linkId, &tid, &recipient, &mpdu]() -> Ptr<WifiMpdu> {
         if (tid == 8 && recipient.IsBroadcast()) // undefined TID and recipient
         {
-            return m_queue->PeekFirstAvailable(linkId, m_qosBlockedDestinations, item);
+            return m_queue->PeekFirstAvailable(linkId, m_qosBlockedDestinations, mpdu);
         }
         if (m_qosBlockedDestinations->IsBlocked(recipient, tid))
         {
             return nullptr;
         }
-        return m_queue->PeekByTidAndAddress(tid, recipient, item);
+        return m_queue->PeekByTidAndAddress(tid, recipient, mpdu);
     };
 
-    item = peek();
+    auto item = peek();
     // remove old packets (must be retransmissions or in flight, otherwise they did
     // not get a sequence number assigned)
     while (item && !item->IsFragment())
     {
-        if ((item->GetHeader().IsRetry() || item->IsInFlight()) && IsQosOldPacket(item))
+        if (item->GetHeader().IsCtl())
+        {
+            NS_LOG_DEBUG("Skipping control frame: " << *item);
+            mpdu = item;
+            item = peek();
+            continue;
+        }
+
+        if (item->HasSeqNoAssigned() && IsQosOldPacket(item))
         {
             NS_LOG_DEBUG("Removing an old packet from EDCA queue: " << *item);
             if (!m_droppedMpduCallback.IsNull())
             {
                 m_droppedMpduCallback(WIFI_MAC_DROP_QOS_OLD_PACKET, item);
             }
-            auto oldItem = item;
+            mpdu = item;
             item = peek();
-            m_queue->Remove(oldItem);
+            m_queue->Remove(mpdu);
+            continue;
         }
-        else if (item->IsInFlight())
+
+        if (auto linkIds = item->GetInFlightLinkIds(); !linkIds.empty()) // MPDU is in-flight
         {
+            // if the MPDU is not already in-flight on the link for which we are requesting an
+            // MPDU and the number of links on which the MPDU is in-flight is less than the
+            // maximum number, then we can transmit this MPDU
+            if (linkIds.count(linkId) == 0 && linkIds.size() < m_nMaxInflights)
+            {
+                break;
+            }
+
+            // if no BA agreement, we cannot have multiple MPDUs in-flight
+            if (item->GetHeader().IsQosData() &&
+                !m_mac->GetBaAgreementEstablishedAsOriginator(item->GetHeader().GetAddr1(),
+                                                              item->GetHeader().GetQosTid()))
+            {
+                NS_LOG_DEBUG("No BA agreement and an MPDU is already in-flight");
+                return nullptr;
+            }
+
             NS_LOG_DEBUG("Skipping in flight MPDU: " << *item);
+            mpdu = item;
             item = peek();
+            continue;
         }
-        else if (item->GetHeader().HasData() &&
-                 !m_mac->CanForwardPacketsTo(item->GetHeader().GetAddr1()))
+
+        if (item->GetHeader().HasData() &&
+            !m_mac->CanForwardPacketsTo(item->GetHeader().GetAddr1()))
         {
             NS_LOG_DEBUG("Skipping frame that cannot be forwarded: " << *item);
+            mpdu = item;
             item = peek();
+            continue;
         }
-        else
-        {
-            break;
-        }
+        break;
     }
-    if (item)
-    {
-        NS_ASSERT(!item->IsInFlight());
-        WifiMacHeader& hdr = item->GetHeader();
 
-        // peek the next sequence number and check if it is within the transmit window
-        // in case of QoS data frame
-        uint16_t sequence =
-            (hdr.IsRetry() ? hdr.GetSequenceNumber() : m_txMiddle->PeekNextSequenceNumberFor(&hdr));
-        if (hdr.IsQosData())
-        {
-            Mac48Address recipient = hdr.GetAddr1();
-            uint8_t tid = hdr.GetQosTid();
+    if (!item)
+    {
+        return nullptr;
+    }
 
-            if (GetBaAgreementEstablished(recipient, tid) &&
-                !IsInWindow(sequence,
-                            GetBaStartingSequence(recipient, tid),
-                            GetBaBufferSize(recipient, tid)))
-            {
-                NS_LOG_DEBUG("Packet beyond the end of the current transmit window");
-                return nullptr;
-            }
-        }
+    WifiMacHeader& hdr = item->GetHeader();
 
-        // Assign a sequence number if this is not a fragment nor a retransmission
-        if (!item->IsFragment() && !hdr.IsRetry())
+    // peek the next sequence number and check if it is within the transmit window
+    // in case of QoS data frame
+    uint16_t sequence = item->HasSeqNoAssigned() ? hdr.GetSequenceNumber()
+                                                 : m_txMiddle->PeekNextSequenceNumberFor(&hdr);
+    if (hdr.IsQosData())
+    {
+        Mac48Address recipient = hdr.GetAddr1();
+        uint8_t tid = hdr.GetQosTid();
+
+        if (m_mac->GetBaAgreementEstablishedAsOriginator(recipient, tid) &&
+            !IsInWindow(sequence,
+                        GetBaStartingSequence(recipient, tid),
+                        GetBaBufferSize(recipient, tid)))
         {
-            hdr.SetSequenceNumber(sequence);
+            NS_LOG_DEBUG("Packet beyond the end of the current transmit window");
+            return nullptr;
         }
-        NS_LOG_DEBUG("Packet peeked from EDCA queue: " << *item);
-        return item;
     }
 
-    return nullptr;
+    // Assign a sequence number if this is not a fragment nor it already has one assigned
+    if (!item->IsFragment() && !item->HasSeqNoAssigned())
+    {
+        hdr.SetSequenceNumber(sequence);
+    }
+    NS_LOG_DEBUG("Packet peeked from EDCA queue: " << *item);
+    return item;
 }
 
 Ptr<WifiMpdu>
@@ -486,15 +506,15 @@
         // we should not be asked to dequeue an MPDU that is beyond the transmit window.
         // Note that PeekNextMpdu() temporarily assigns the next available sequence number
         // to the peeked frame
-        NS_ASSERT(!GetBaAgreementEstablished(recipient, tid) ||
-                  IsInWindow(peekedItem->GetHeader().GetSequenceNumber(),
-                             GetBaStartingSequence(recipient, tid),
-                             GetBaBufferSize(recipient, tid)));
+        NS_ASSERT(!m_mac->GetBaAgreementEstablishedAsOriginator(recipient, tid) ||
+                  IsInWindow(
+                      peekedItem->GetHeader().GetSequenceNumber(),
+                      GetBaStartingSequence(peekedItem->GetOriginal()->GetHeader().GetAddr1(), tid),
+                      GetBaBufferSize(peekedItem->GetOriginal()->GetHeader().GetAddr1(), tid)));
 
         // try A-MSDU aggregation
         if (m_mac->GetHtSupported() && !recipient.IsBroadcast() &&
-            !peekedItem->GetHeader().IsRetry() && !peekedItem->IsFragment() &&
-            !peekedItem->IsInFlight())
+            !peekedItem->HasSeqNoAssigned() && !peekedItem->IsFragment())
         {
             auto htFem = StaticCast<HtFrameExchangeManager>(qosFem);
             mpdu = htFem->GetMsduAggregator()->GetNextAmsdu(peekedItem, txParams, availableTime);
@@ -524,25 +544,15 @@
 {
     NS_LOG_FUNCTION(this << *mpdu);
 
-    if (!mpdu->IsFragment() && !mpdu->GetHeader().IsRetry() && !mpdu->IsInFlight())
+    if (!mpdu->IsFragment() && !mpdu->HasSeqNoAssigned())
     {
-        uint16_t sequence = m_txMiddle->GetNextSequenceNumberFor(&mpdu->GetHeader());
-        mpdu->GetHeader().SetSequenceNumber(sequence);
+        // in case of 11be MLDs, sequence numbers refer to the MLD address
+        auto origMpdu = m_queue->GetOriginal(mpdu);
+        uint16_t sequence = m_txMiddle->GetNextSequenceNumberFor(&origMpdu->GetHeader());
+        mpdu->AssignSeqNo(sequence);
     }
 }
 
-BlockAckReqType
-QosTxop::GetBlockAckReqType(Mac48Address recipient, uint8_t tid) const
-{
-    return m_baManager->GetBlockAckReqType(recipient, tid);
-}
-
-BlockAckType
-QosTxop::GetBlockAckType(Mac48Address recipient, uint8_t tid) const
-{
-    return m_baManager->GetBlockAckType(recipient, tid);
-}
-
 void
 QosTxop::NotifyChannelAccessed(uint8_t linkId, Time txopDuration)
 {
@@ -594,11 +604,11 @@
 }
 
 void
-QosTxop::GotAddBaResponse(const MgtAddBaResponseHeader* respHdr, Mac48Address recipient)
+QosTxop::GotAddBaResponse(const MgtAddBaResponseHeader& respHdr, Mac48Address recipient)
 {
     NS_LOG_FUNCTION(this << respHdr << recipient);
-    uint8_t tid = respHdr->GetTid();
-    if (respHdr->GetStatusCode().IsSuccess())
+    uint8_t tid = respHdr.GetTid();
+    if (respHdr.GetStatusCode().IsSuccess())
     {
         NS_LOG_DEBUG("block ack agreement established with " << recipient << " tid " << +tid);
         // A (destination, TID) pair is "blocked" (i.e., no more packets are sent)
@@ -614,18 +624,17 @@
         {
             startingSeq = peekedItem->GetHeader().GetSequenceNumber();
         }
-        m_baManager->UpdateAgreement(respHdr, recipient, startingSeq);
+        m_baManager->UpdateOriginatorAgreement(respHdr, recipient, startingSeq);
     }
     else
     {
         NS_LOG_DEBUG("discard ADDBA response" << recipient);
-        m_baManager->NotifyAgreementRejected(recipient, tid);
+        m_baManager->NotifyOriginatorAgreementRejected(recipient, tid);
     }
 
-    if (HasFramesToTransmit(SINGLE_LINK_OP_ID) &&
-        GetLink(SINGLE_LINK_OP_ID).access == NOT_REQUESTED)
+    for (uint8_t linkId = 0; linkId < GetNLinks(); linkId++)
     {
-        m_mac->GetChannelAccessManager(SINGLE_LINK_OP_ID)->RequestAccess(this);
+        StartAccessIfNeeded(linkId);
     }
 }
 
@@ -634,7 +643,21 @@
 {
     NS_LOG_FUNCTION(this << delBaHdr << recipient);
     NS_LOG_DEBUG("received DELBA frame from=" << recipient);
-    m_baManager->DestroyAgreement(recipient, delBaHdr->GetTid());
+    m_baManager->DestroyOriginatorAgreement(recipient, delBaHdr->GetTid());
+}
+
+void
+QosTxop::NotifyOriginatorAgreementNoReply(const Mac48Address& recipient, uint8_t tid)
+{
+    NS_LOG_FUNCTION(this << recipient << tid);
+
+    m_baManager->NotifyOriginatorAgreementNoReply(recipient, tid);
+    // the recipient has been "unblocked" and transmissions can resume using normal
+    // acknowledgment, hence start access (if needed) on all the links
+    for (uint8_t linkId = 0; linkId < GetNLinks(); linkId++)
+    {
+        StartAccessIfNeeded(linkId);
+    }
 }
 
 void
@@ -642,9 +665,12 @@
 {
     NS_ASSERT(mpdu->GetHeader().IsQosData());
     // If there is an established BA agreement, store the packet in the queue of outstanding packets
-    if (GetBaAgreementEstablished(mpdu->GetHeader().GetAddr1(), mpdu->GetHeader().GetQosTid()))
+    if (m_mac->GetBaAgreementEstablishedAsOriginator(mpdu->GetHeader().GetAddr1(),
+                                                     mpdu->GetHeader().GetQosTid()))
     {
-        m_baManager->StorePacket(mpdu);
+        NS_ASSERT(mpdu->IsQueued());
+        NS_ASSERT(m_queue->GetAc() == mpdu->GetQueueAc());
+        m_baManager->StorePacket(m_queue->GetOriginal(mpdu));
     }
 }
 
@@ -681,16 +707,11 @@
 {
     NS_LOG_FUNCTION(this << recipient << +tid);
     // If agreement is still pending, ADDBA response is not received
-    if (m_baManager->ExistsAgreementInState(recipient, tid, OriginatorBlockAckAgreement::PENDING))
+    if (auto agreement = m_baManager->GetAgreementAsOriginator(recipient, tid);
+        agreement && agreement->get().IsPending())
     {
-        m_baManager->NotifyAgreementNoReply(recipient, tid);
+        NotifyOriginatorAgreementNoReply(recipient, tid);
         Simulator::Schedule(m_failedAddBaTimeout, &QosTxop::ResetBa, this, recipient, tid);
-        GenerateBackoff(SINGLE_LINK_OP_ID);
-        if (HasFramesToTransmit(SINGLE_LINK_OP_ID) &&
-            GetLink(SINGLE_LINK_OP_ID).access == NOT_REQUESTED)
-        {
-            m_mac->GetChannelAccessManager(SINGLE_LINK_OP_ID)->RequestAccess(this);
-        }
     }
 }
 
@@ -702,12 +723,10 @@
     // before this function is called, a DELBA request may arrive, which causes
     // the agreement to be deleted. Hence, check if an agreement exists before
     // notifying that the agreement has to be reset.
-    if (m_baManager->ExistsAgreement(recipient, tid) &&
-        !m_baManager->ExistsAgreementInState(recipient,
-                                             tid,
-                                             OriginatorBlockAckAgreement::ESTABLISHED))
+    if (auto agreement = m_baManager->GetAgreementAsOriginator(recipient, tid);
+        agreement && !agreement->get().IsEstablished())
     {
-        m_baManager->NotifyAgreementReset(recipient, tid);
+        m_baManager->NotifyOriginatorAgreementReset(recipient, tid);
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/qos-txop.h ns-3.38/src/wifi/model/qos-txop.h
--- ns-3.37/src/wifi/model/qos-txop.h	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/qos-txop.h	2023-03-16 20:54:23.860869400 -0700
@@ -117,16 +117,6 @@
      * \param address recipient address of the peer station
      * \param tid traffic ID.
      *
-     * \return true if a block ack agreement is established, false otherwise.
-     *
-     * Checks if a block ack agreement is established with station addressed by
-     * <i>recipient</i> for TID <i>tid</i>.
-     */
-    bool GetBaAgreementEstablished(Mac48Address address, uint8_t tid) const;
-    /**
-     * \param address recipient address of the peer station
-     * \param tid traffic ID.
-     *
      * \return the negotiated buffer size during ADDBA handshake.
      *
      * Returns the negotiated buffer size during ADDBA handshake with station addressed by
@@ -145,24 +135,6 @@
      */
     uint16_t GetBaStartingSequence(Mac48Address address, uint8_t tid) const;
     /**
-     * \param recipient MAC address of recipient
-     * \param tid traffic ID
-     *
-     * \return the type of Block Ack Requests sent to the recipient
-     *
-     * This function returns the type of Block Ack Requests sent to the recipient.
-     */
-    BlockAckReqType GetBlockAckReqType(Mac48Address recipient, uint8_t tid) const;
-    /**
-     * \param recipient MAC address
-     * \param tid traffic ID
-     *
-     * \return the type of Block Acks sent by the recipient
-     *
-     * This function returns the type of Block Acks sent by the recipient.
-     */
-    BlockAckType GetBlockAckType(Mac48Address recipient, uint8_t tid) const;
-    /**
      * \param recipient Address of recipient.
      * \param tid traffic ID.
      * \return the BlockAckRequest to send
@@ -172,15 +144,7 @@
      * corresponding to the given TID. A block ack agreement with the given recipient
      * for the given TID must have been established by such QosTxop.
      */
-    Ptr<const WifiMpdu> PrepareBlockAckRequest(Mac48Address recipient, uint8_t tid) const;
-    /**
-     * \param bar the BlockAckRequest to schedule
-     * \param skipIfNoDataQueued do not send if there is no data queued
-     *
-     * Request the block ack manager to schedule the transmission of the given
-     * BlockAckRequest.
-     */
-    void ScheduleBar(Ptr<const WifiMpdu> bar, bool skipIfNoDataQueued = false);
+    Ptr<WifiMpdu> PrepareBlockAckRequest(Mac48Address recipient, uint8_t tid) const;
 
     /* Event handlers */
     /**
@@ -189,7 +153,7 @@
      * \param respHdr ADDBA response header.
      * \param recipient address of the recipient.
      */
-    void GotAddBaResponse(const MgtAddBaResponseHeader* respHdr, Mac48Address recipient);
+    void GotAddBaResponse(const MgtAddBaResponseHeader& respHdr, Mac48Address recipient);
     /**
      * Event handler when a DELBA frame is received.
      *
@@ -198,6 +162,14 @@
      */
     void GotDelBaFrame(const MgtDelBaHeader* delBaHdr, Mac48Address recipient);
     /**
+     * Take action upon notification of ADDBA_REQUEST frame being discarded
+     * (likely due to exceeded max retry limit).
+     *
+     * \param recipient the intended recipient of the ADDBA_REQUEST frame
+     * \param tid the TID
+     */
+    void NotifyOriginatorAgreementNoReply(const Mac48Address& recipient, uint8_t tid);
+    /**
      * Callback when ADDBA response is not received after timeout.
      *
      * \param recipient MAC address of recipient
@@ -291,8 +263,8 @@
     /**
      * Peek the next frame to transmit on the given link to the given receiver and of the given TID
      * from the EDCA queue. If <i>tid</i> is equal to 8 (invalid value) and <i>recipient</i>
-     * is the broadcast address, the first available frame is returned. If <i>item</i>
-     * is not a null pointer, the search starts from the packet following <i>item</i>
+     * is the broadcast address, the first available frame is returned. If <i>mpdu</i>
+     * is not a null pointer, the search starts from the MPDU following <i>mpdu</i>
      * in the queue; otherwise, the search starts from the head of the queue.
      * Note that A-MSDU aggregation is never attempted. If the frame has never been
      * transmitted, it is assigned a sequence number peeked from MacTxMiddle.
@@ -301,13 +273,13 @@
      * \param linkId the ID of the given link
      * \param tid traffic ID.
      * \param recipient the receiver station address.
-     * \param item the item after which the search starts from
+     * \param mpdu the MPDU after which the search starts from
      * \returns the peeked frame.
      */
     Ptr<WifiMpdu> PeekNextMpdu(uint8_t linkId,
                                uint8_t tid = 8,
                                Mac48Address recipient = Mac48Address::GetBroadcast(),
-                               Ptr<WifiMpdu> item = nullptr);
+                               Ptr<const WifiMpdu> mpdu = nullptr);
     /**
      * Prepare the frame to transmit on the given link starting from the MPDU that has been
      * previously peeked by calling PeekNextMpdu. A frame is only returned if it meets the
@@ -505,6 +477,9 @@
     Time m_failedAddBaTimeout;            //!< timeout after failed BA agreement
     bool m_useExplicitBarAfterMissedBlockAck; //!< flag whether explicit BlockAckRequest should be
                                               //!< sent upon missed BlockAck Response
+    uint8_t m_nMaxInflights;                  //!< the maximum number of links on which
+                                              //!< an MPDU can be in-flight at the same
+                                              //!< time
 
     /// TracedCallback for TXOP trace typedef
     typedef TracedCallback<Time /* start time */, Time /* duration */, uint8_t /* link ID*/>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/qos-utils.cc ns-3.38/src/wifi/model/qos-utils.cc
--- ns-3.37/src/wifi/model/qos-utils.cc	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/qos-utils.cc	2023-03-16 20:54:23.860869400 -0700
@@ -84,7 +84,7 @@
 }
 
 bool
-operator>(enum AcIndex left, enum AcIndex right)
+operator>(AcIndex left, AcIndex right)
 {
     NS_ABORT_MSG_IF(left > 3 || right > 3, "Cannot compare non-QoS ACs");
 
@@ -104,7 +104,7 @@
 }
 
 bool
-operator>=(enum AcIndex left, enum AcIndex right)
+operator>=(AcIndex left, AcIndex right)
 {
     NS_ABORT_MSG_IF(left > 3 || right > 3, "Cannot compare non-QoS ACs");
 
@@ -112,21 +112,23 @@
 }
 
 bool
-operator<(enum AcIndex left, enum AcIndex right)
+operator<(AcIndex left, AcIndex right)
 {
     return !(left >= right);
 }
 
 bool
-operator<=(enum AcIndex left, enum AcIndex right)
+operator<=(AcIndex left, AcIndex right)
 {
     return !(left > right);
 }
 
-const std::map<AcIndex, WifiAc> wifiAcList = {{AC_BE, {0, 3}},
-                                              {AC_BK, {1, 2}},
-                                              {AC_VI, {4, 5}},
-                                              {AC_VO, {6, 7}}};
+const std::map<AcIndex, WifiAc> wifiAcList = {
+    {AC_BE, {0, 3}},
+    {AC_BK, {1, 2}},
+    {AC_VI, {4, 5}},
+    {AC_VO, {6, 7}},
+};
 
 AcIndex
 QosUtilsMapTidToAc(uint8_t tid)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/qos-utils.h ns-3.38/src/wifi/model/qos-utils.h
--- ns-3.37/src/wifi/model/qos-utils.h	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/qos-utils.h	2023-03-16 20:54:23.860869400 -0700
@@ -34,8 +34,6 @@
 
 typedef std::pair<Mac48Address, uint8_t> WifiAddressTidPair; //!< (MAC address, TID) pair
 
-#define WIFI_TID_UNDEFINED 0xff
-
 /**
  * Function object to compute the hash of a (MAC address, TID) pair
  */
@@ -136,7 +134,7 @@
  * \param right the AC on the right of operator>
  * \return true if the AC on the left has higher priority than the AC on the right
  */
-bool operator>(enum AcIndex left, enum AcIndex right);
+bool operator>(AcIndex left, AcIndex right);
 
 /**
  * \ingroup wifi
@@ -147,7 +145,7 @@
  * \param right the AC on the right of operator>=
  * \return true if the AC on the left has higher or the same priority than the AC on the right
  */
-bool operator>=(enum AcIndex left, enum AcIndex right);
+bool operator>=(AcIndex left, AcIndex right);
 
 /**
  * \ingroup wifi
@@ -158,7 +156,7 @@
  * \param right the AC on the right of operator<
  * \return true if the AC on the left has lower priority than the AC on the right
  */
-bool operator<(enum AcIndex left, enum AcIndex right);
+bool operator<(AcIndex left, AcIndex right);
 
 /**
  * \ingroup wifi
@@ -169,7 +167,7 @@
  * \param right the AC on the right of operator<=
  * \return true if the AC on the left has lower or the same priority than the AC on the right
  */
-bool operator<=(enum AcIndex left, enum AcIndex right);
+bool operator<=(AcIndex left, AcIndex right);
 
 /**
  * Map containing the four ACs in increasing order of priority (according to
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/rate-control/constant-rate-wifi-manager.cc ns-3.38/src/wifi/model/rate-control/constant-rate-wifi-manager.cc
--- ns-3.37/src/wifi/model/rate-control/constant-rate-wifi-manager.cc	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/rate-control/constant-rate-wifi-manager.cc	2023-03-16 20:54:23.860869400 -0700
@@ -25,7 +25,7 @@
 #include "ns3/wifi-tx-vector.h"
 #include "ns3/wifi-utils.h"
 
-#define Min(a, b) ((a < b) ? a : b)
+#include <algorithm>
 
 namespace ns3
 {
@@ -127,7 +127,7 @@
 ConstantRateWifiManager::DoGetDataTxVector(WifiRemoteStation* st, uint16_t allowedWidth)
 {
     NS_LOG_FUNCTION(this << st << allowedWidth);
-    uint8_t nss = Min(GetMaxNumberOfTransmitStreams(), GetNumberOfSupportedStreams(st));
+    uint8_t nss = std::min(GetMaxNumberOfTransmitStreams(), GetNumberOfSupportedStreams(st));
     if (m_dataMode.GetModulationClass() == WIFI_MOD_CLASS_HT)
     {
         nss = 1 + (m_dataMode.GetMcsValue() / 8);
@@ -142,7 +142,7 @@
         GetNumberOfAntennas(),
         nss,
         0,
-        GetChannelWidthForTransmission(m_dataMode, allowedWidth, GetChannelWidth(st)),
+        GetPhy()->GetTxBandwidth(m_dataMode, std::min(allowedWidth, GetChannelWidth(st))),
         GetAggregation(st));
 }
 
@@ -160,7 +160,7 @@
         1,
         1,
         0,
-        GetChannelWidthForTransmission(m_ctlMode, GetPhy()->GetChannelWidth(), GetChannelWidth(st)),
+        GetPhy()->GetTxBandwidth(m_ctlMode, GetChannelWidth(st)),
         GetAggregation(st));
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/rate-control/ideal-wifi-manager.cc ns-3.38/src/wifi/model/rate-control/ideal-wifi-manager.cc
--- ns-3.37/src/wifi/model/rate-control/ideal-wifi-manager.cc	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/rate-control/ideal-wifi-manager.cc	2023-03-16 20:54:23.860869400 -0700
@@ -571,7 +571,7 @@
         GetNumberOfAntennas(),
         selectedNss,
         0,
-        GetChannelWidthForTransmission(maxMode, channelWidth),
+        GetPhy()->GetTxBandwidth(maxMode, channelWidth),
         GetAggregation(station)};
     uint64_t maxDataRate = maxMode.GetDataRate(bestTxVector);
     if (m_currentRate != maxDataRate)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc ns-3.38/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc
--- ns-3.37/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc	2023-03-16 20:54:23.860869400 -0700
@@ -1091,7 +1091,7 @@
             GetNumberOfAntennas(),
             group.streams,
             GetNess(station),
-            GetChannelWidthForTransmission(mode, group.chWidth),
+            GetPhy()->GetTxBandwidth(mode, group.chWidth),
             GetAggregation(station) && !station->m_isSampling};
         uint64_t dataRate = mode.GetDataRate(txVector);
         if (m_currentRate != dataRate && !station->m_isSampling)
@@ -1181,9 +1181,7 @@
             1,
             1,
             0,
-            GetChannelWidthForTransmission(rtsRate,
-                                           GetPhy()->GetChannelWidth(),
-                                           GetChannelWidth(station)),
+            GetPhy()->GetTxBandwidth(rtsRate, GetChannelWidth(station)),
             GetAggregation(station));
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/rate-control/minstrel-wifi-manager.cc ns-3.38/src/wifi/model/rate-control/minstrel-wifi-manager.cc
--- ns-3.37/src/wifi/model/rate-control/minstrel-wifi-manager.cc	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/rate-control/minstrel-wifi-manager.cc	2023-03-16 20:54:23.864869400 -0700
@@ -1105,7 +1105,7 @@
 }
 
 void
-MinstrelWifiManager::PrintSampleTable(MinstrelWifiRemoteStation* station)
+MinstrelWifiManager::PrintSampleTable(MinstrelWifiRemoteStation* station) const
 {
     uint8_t numSampleRates = station->m_nModes;
     std::stringstream table;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/rate-control/minstrel-wifi-manager.h ns-3.38/src/wifi/model/rate-control/minstrel-wifi-manager.h
--- ns-3.37/src/wifi/model/rate-control/minstrel-wifi-manager.h	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/rate-control/minstrel-wifi-manager.h	2023-03-16 20:54:23.864869400 -0700
@@ -328,7 +328,7 @@
      *
      * \param station the station object
      */
-    void PrintSampleTable(MinstrelWifiRemoteStation* station);
+    void PrintSampleTable(MinstrelWifiRemoteStation* station) const;
 
     /**
      * Print Minstrel Table.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/rate-control/rraa-wifi-manager.cc ns-3.38/src/wifi/model/rate-control/rraa-wifi-manager.cc
--- ns-3.37/src/wifi/model/rate-control/rraa-wifi-manager.cc	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/rate-control/rraa-wifi-manager.cc	2023-03-16 20:54:23.864869400 -0700
@@ -191,7 +191,7 @@
 RraaWifiManager::GetThresholds(RraaWifiRemoteStation* station, WifiMode mode) const
 {
     NS_LOG_FUNCTION(this << station << mode);
-    struct WifiRraaThresholds threshold;
+    WifiRraaThresholds threshold;
     for (RraaThresholdsTable::const_iterator i = station->m_thresholds.begin();
          i != station->m_thresholds.end();
          i++)
